diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/class-http.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/class-http.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-includes/class-http.php	2013-08-18 03:22:03.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-includes/class-http.php	2013-10-23 09:40:10.000000000 -0500
***************
*** 15,29 ****
  /**
   * WordPress HTTP Class for managing HTTP Transports and making HTTP requests.
   *
!  * This class is called for the functionality of making HTTP requests and replaces Snoopy
!  * functionality. There is no available functionality to add HTTP transport implementations, since
!  * most of the HTTP transports are added and available for use.
!  *
!  * There are no properties, because none are needed and for performance reasons. Some of the
!  * functions are static and while they do have some overhead over functions in PHP4, the purpose is
!  * maintainability. When PHP5 is finally the requirement, it will be easy to add the static keyword
!  * to the code. It is not as easy to convert a function to a method after enough code uses the old
!  * way.
   *
   * Debugging includes several actions, which pass different variables for debugging the HTTP API.
   *
--- 15,23 ----
  /**
   * WordPress HTTP Class for managing HTTP Transports and making HTTP requests.
   *
!  * This class is used to consistently make outgoing HTTP requests easy for developers
!  * while still being compatible with the many PHP configurations under which
!  * WordPress runs.
   *
   * Debugging includes several actions, which pass different variables for debugging the HTTP API.
   *
***************
*** 42,49 ****
  	 * using http_build_query().
  	 *
  	 * The only URI that are supported in the HTTP Transport implementation are the HTTP and HTTPS
! 	 * protocols. HTTP and HTTPS are assumed so the server might not know how to handle the send
! 	 * headers. Other protocols are unsupported and most likely will fail.
  	 *
  	 * The defaults are 'method', 'timeout', 'redirection', 'httpversion', 'blocking' and
  	 * 'user-agent'.
--- 36,42 ----
  	 * using http_build_query().
  	 *
  	 * The only URI that are supported in the HTTP Transport implementation are the HTTP and HTTPS
! 	 * protocols.
  	 *
  	 * The defaults are 'method', 'timeout', 'redirection', 'httpversion', 'blocking' and
  	 * 'user-agent'.
***************
*** 55,78 ****
  	 * accept setting that value.
  	 *
  	 * The 'httpversion' option is used to sent the HTTP version and accepted values are '1.0', and
! 	 * '1.1' and should be a string. Version 1.1 is not supported, because of chunk response. The
! 	 * 'user-agent' option is the user-agent and is used to replace the default user-agent, which is
! 	 * 'WordPress/WP_Version', where WP_Version is the value from $wp_version.
! 	 *
! 	 * 'blocking' is the default, which is used to tell the transport, whether it should halt PHP
! 	 * while it performs the request or continue regardless. Actually, that isn't entirely correct.
! 	 * Blocking mode really just means whether the fread should just pull what it can whenever it
! 	 * gets bytes or if it should wait until it has enough in the buffer to read or finishes reading
! 	 * the entire content. It doesn't actually always mean that PHP will continue going after making
! 	 * the request.
  	 *
  	 * @access public
  	 * @since 2.7.0
- 	 * @todo Refactor this code. The code in this method extends the scope of its original purpose
- 	 *		and should be refactored to allow for cleaner abstraction and reduce duplication of the
- 	 *		code. One suggestion is to create a class specifically for the arguments, however
- 	 *		preliminary refactoring to this affect has affect more than just the scope of the
- 	 *		arguments. Something to ponder at least.
  	 *
  	 * @param string $url URI resource.
  	 * @param str|array $args Optional. Override the defaults.
--- 48,64 ----
  	 * accept setting that value.
  	 *
  	 * The 'httpversion' option is used to sent the HTTP version and accepted values are '1.0', and
! 	 * '1.1' and should be a string. The 'user-agent' option is the user-agent and is used to
! 	 * replace the default user-agent, which is 'WordPress/WP_Version', where WP_Version is the
! 	 * value from $wp_version.
! 	 *
! 	 * The 'blocking' parameter can be used to specify if the calling code requires the result of
! 	 * the HTTP request. If set to false, the request will be sent to the remote server, and
! 	 * processing returned to the calling code immediately, the caller will know if the request
! 	 * suceeded or failed, but will not receive any response from the remote server.
  	 *
  	 * @access public
  	 * @since 2.7.0
  	 *
  	 * @param string $url URI resource.
  	 * @param str|array $args Optional. Override the defaults.
***************
*** 95,100 ****
--- 81,87 ----
  			'compress' => false,
  			'decompress' => true,
  			'sslverify' => true,
+ 			'sslcertificates' => ABSPATH . WPINC . '/certificates/ca-bundle.crt',
  			'stream' => false,
  			'filename' => null,
  			'limit_response_size' => null,
***************
*** 158,164 ****
  			$r['headers'] = array();
  
  		if ( ! is_array( $r['headers'] ) ) {
! 			$processedHeaders = WP_Http::processHeaders( $r['headers'] );
  			$r['headers'] = $processedHeaders['headers'];
  		}
  
--- 145,151 ----
  			$r['headers'] = array();
  
  		if ( ! is_array( $r['headers'] ) ) {
! 			$processedHeaders = WP_Http::processHeaders( $r['headers'], $url );
  			$r['headers'] = $processedHeaders['headers'];
  		}
  
***************
*** 172,180 ****
--- 159,174 ----
  			unset( $r['headers']['user-agent'] );
  		}
  
+ 		if ( '1.1' == $r['httpversion'] && !isset( $r['headers']['connection'] ) ) {
+ 			$r['headers']['connection'] = 'close';
+ 		}
+ 
  		// Construct Cookie: header if any cookies are set
  		WP_Http::buildCookieHeader( $r );
  
+ 		// Avoid issues where mbstring.func_overload is enabled
+ 		mbstring_binary_safe_encoding();
+ 
  		if ( ! isset( $r['headers']['Accept-Encoding'] ) ) {
  			if ( $encoding = WP_Http_Encoding::accept_encoding( $url, $r ) )
  				$r['headers']['Accept-Encoding'] = $encoding;
***************
*** 195,201 ****
  				$r['headers']['Content-Length'] = strlen( $r['body'] );
  		}
  
! 		return $this->_dispatch_request($url, $r);
  	}
  
  	/**
--- 189,212 ----
  				$r['headers']['Content-Length'] = strlen( $r['body'] );
  		}
  
! 		$response = $this->_dispatch_request( $url, $r );
! 
! 		reset_mbstring_encoding();
! 
! 		if ( is_wp_error( $response ) )
! 			return $response;
! 
! 		// Append cookies that were used in this request to the response
! 		if ( ! empty( $r['cookies'] ) ) {
! 			$cookies_set = wp_list_pluck( $response['cookies'], 'name' );
! 			foreach ( $r['cookies'] as $cookie ) {
! 				if ( ! in_array( $cookie->name, $cookies_set ) && $cookie->test( $url ) ) {
! 					$response['cookies'][] = $cookie;
! 				}
! 			}
! 		}
! 
! 		return $response;
  	}
  
  	/**
***************
*** 210,216 ****
  	 * @return string|bool Class name for the first transport that claims to support the request. False if no transport claims to support the request.
  	 */
  	public function _get_first_available_transport( $args, $url = null ) {
! 		$request_order = array( 'curl', 'streams', 'fsockopen' );
  
  		// Loop over each transport on each HTTP request looking for one which will serve this request's needs
  		foreach ( $request_order as $transport ) {
--- 221,227 ----
  	 * @return string|bool Class name for the first transport that claims to support the request. False if no transport claims to support the request.
  	 */
  	public function _get_first_available_transport( $args, $url = null ) {
! 		$request_order = apply_filters( 'http_api_transports', array( 'curl', 'streams' ), $args, $url );
  
  		// Loop over each transport on each HTTP request looking for one which will serve this request's needs
  		foreach ( $request_order as $transport ) {
***************
*** 232,244 ****
  	 * Tests each transport in order to find a transport which matches the request arguments.
  	 * Also caches the transport instance to be used later.
  	 *
! 	 * The order for blocking requests is cURL, Streams, and finally Fsockopen.
! 	 * The order for non-blocking requests is cURL, Streams and Fsockopen().
! 	 *
! 	 * There are currently issues with "localhost" not resolving correctly with DNS. This may cause
! 	 * an error "failed to open stream: A connection attempt failed because the connected party did
! 	 * not properly respond after a period of time, or established connection failed because [the]
! 	 * connected host has failed to respond."
  	 *
  	 * @since 3.2.0
  	 * @access private
--- 243,249 ----
  	 * Tests each transport in order to find a transport which matches the request arguments.
  	 * Also caches the transport instance to be used later.
  	 *
! 	 * The order for requests is cURL, and then PHP Streams.
  	 *
  	 * @since 3.2.0
  	 * @access private
***************
*** 349,358 ****
  	 * @since 2.7.0
  	 *
  	 * @param string|array $headers
  	 * @return array Processed string headers. If duplicate headers are encountered,
  	 * 					Then a numbered array is returned as the value of that header-key.
  	 */
! 	public static function processHeaders($headers) {
  		// split headers, one per array element
  		if ( is_string($headers) ) {
  			// tolerate line terminator: CRLF = LF (RFC 2616 19.3)
--- 354,364 ----
  	 * @since 2.7.0
  	 *
  	 * @param string|array $headers
+ 	 * @param string $url The URL that was requested
  	 * @return array Processed string headers. If duplicate headers are encountered,
  	 * 					Then a numbered array is returned as the value of that header-key.
  	 */
! 	public static function processHeaders( $headers, $url = '' ) {
  		// split headers, one per array element
  		if ( is_string($headers) ) {
  			// tolerate line terminator: CRLF = LF (RFC 2616 19.3)
***************
*** 400,406 ****
  				$newheaders[ $key ] = $value;
  			}
  			if ( 'set-cookie' == $key )
! 				$cookies[] = new WP_Http_Cookie( $value );
  		}
  
  		return array('response' => $response, 'headers' => $newheaders, 'cookies' => $cookies);
--- 406,412 ----
  				$newheaders[ $key ] = $value;
  			}
  			if ( 'set-cookie' == $key )
! 				$cookies[] = new WP_Http_Cookie( $value, $url );
  		}
  
  		return array('response' => $response, 'headers' => $newheaders, 'cookies' => $cookies);
***************
*** 409,417 ****
  	/**
  	 * Takes the arguments for a ::request() and checks for the cookie array.
  	 *
! 	 * If it's found, then it's assumed to contain WP_Http_Cookie objects, which are each parsed
! 	 * into strings and added to the Cookie: header (within the arguments array). Edits the array by
! 	 * reference.
  	 *
  	 * @access public
  	 * @version 2.8.0
--- 415,423 ----
  	/**
  	 * Takes the arguments for a ::request() and checks for the cookie array.
  	 *
! 	 * If it's found, then it upgrades any basic name => value pairs to WP_Http_Cookie instances,
! 	 * which are each parsed into strings and added to the Cookie: header (within the arguments array).
! 	 * Edits the array by reference.
  	 *
  	 * @access public
  	 * @version 2.8.0
***************
*** 421,426 ****
--- 427,438 ----
  	 */
  	public static function buildCookieHeader( &$r ) {
  		if ( ! empty($r['cookies']) ) {
+ 			// Upgrade any name => value cookie pairs to WP_HTTP_Cookie instances
+ 			foreach ( $r['cookies'] as $name => $value ) {
+ 				if ( ! is_object( $value ) )
+ 					$r['cookies'][ $name ] = new WP_HTTP_Cookie( array( 'name' => $name, 'value' => $value ) );
+ 			}
+ 
  			$cookies_header = '';
  			foreach ( (array) $r['cookies'] as $cookie ) {
  				$cookies_header .= $cookie->getHeaderValue() . '; ';
***************
*** 433,444 ****
  	/**
  	 * Decodes chunk transfer-encoding, based off the HTTP 1.1 specification.
  	 *
! 	 * Based off the HTTP http_encoding_dechunk function. Does not support UTF-8. Does not support
! 	 * returning footer headers. Shouldn't be too difficult to support it though.
  	 *
  	 * @link http://tools.ietf.org/html/rfc2616#section-19.4.6 Process for chunked decoding.
  	 *
- 	 * @todo Add support for footer chunked headers.
  	 * @access public
  	 * @since 2.7.0
  	 * @static
--- 446,455 ----
  	/**
  	 * Decodes chunk transfer-encoding, based off the HTTP 1.1 specification.
  	 *
! 	 * Based off the HTTP http_encoding_dechunk function.
  	 *
  	 * @link http://tools.ietf.org/html/rfc2616#section-19.4.6 Process for chunked decoding.
  	 *
  	 * @access public
  	 * @since 2.7.0
  	 * @static
***************
*** 446,480 ****
  	 * @param string $body Body content
  	 * @return string Chunked decoded body on success or raw body on failure.
  	 */
! 	function chunkTransferDecode($body) {
! 		$body = str_replace(array("\r\n", "\r"), "\n", $body);
! 		// The body is not chunked encoding or is malformed.
! 		if ( ! preg_match( '/^[0-9a-f]+(\s|\n)+/mi', trim($body) ) )
  			return $body;
  
! 		$parsedBody = '';
! 		//$parsedHeaders = array(); Unsupported
  
  		while ( true ) {
! 			$hasChunk = (bool) preg_match( '/^([0-9a-f]+)(\s|\n)+/mi', $body, $match );
! 
! 			if ( $hasChunk ) {
! 				if ( empty( $match[1] ) )
! 					return $body;
! 
! 				$length = hexdec( $match[1] );
! 				$chunkLength = strlen( $match[0] );
! 
! 				$strBody = substr($body, $chunkLength, $length);
! 				$parsedBody .= $strBody;
! 
! 				$body = ltrim(str_replace(array($match[0], $strBody), '', $body), "\n");
! 
! 				if ( "0" == trim($body) )
! 					return $parsedBody; // Ignore footer headers.
! 			} else {
! 				return $body;
! 			}
  		}
  	}
  
--- 457,487 ----
  	 * @param string $body Body content
  	 * @return string Chunked decoded body on success or raw body on failure.
  	 */
! 	public static function chunkTransferDecode( $body ) {
! 		// The body is not chunked encoded or is malformed.
! 		if ( ! preg_match( '/^([0-9a-f]+)[^\r\n]*\r\n/i', trim( $body ) ) )
  			return $body;
  
! 		$parsed_body = '';
! 		$body_original = $body; // We'll be altering $body, so need a backup in case of error
  
  		while ( true ) {
! 			$has_chunk = (bool) preg_match( '/^([0-9a-f]+)[^\r\n]*\r\n/i', $body, $match );
! 			if ( ! $has_chunk || empty( $match[1] ) )
! 				return $body_original;
! 
! 			$length = hexdec( $match[1] );
! 			$chunk_length = strlen( $match[0] );
! 
! 			// Parse out the chunk of data
! 			$parsed_body .= substr( $body, $chunk_length, $length );
! 
! 			// Remove the chunk from the raw data
! 			$body = substr( $body, $length + $chunk_length );
! 
! 			// End of document
! 			if ( '0' === trim( $body ) )
! 				return $parsed_body;
  		}
  	}
  
***************
*** 502,520 ****
  		if ( ! defined( 'WP_HTTP_BLOCK_EXTERNAL' ) || ! WP_HTTP_BLOCK_EXTERNAL )
  			return false;
  
! 		// parse_url() only handles http, https type URLs, and will emit E_WARNING on failure.
! 		// This will be displayed on blogs, which is not reasonable.
! 		$check = @parse_url($uri);
! 
! 		/* Malformed URL, can not process, but this could mean ssl, so let through anyway.
! 		 *
! 		 * This isn't very security sound. There are instances where a hacker might attempt
! 		 * to bypass the proxy and this check. However, the reason for this behavior is that
! 		 * WordPress does not do any checking currently for non-proxy requests, so it is keeps with
! 		 * the default unsecure nature of the HTTP request.
! 		 */
! 		if ( $check === false )
! 			return false;
  
  		$home = parse_url( get_option('siteurl') );
  
--- 509,517 ----
  		if ( ! defined( 'WP_HTTP_BLOCK_EXTERNAL' ) || ! WP_HTTP_BLOCK_EXTERNAL )
  			return false;
  
! 		$check = parse_url($uri);
! 		if ( ! $check )
! 			return true;
  
  		$home = parse_url( get_option('siteurl') );
  
***************
*** 533,539 ****
  			if ( false !== strpos(WP_ACCESSIBLE_HOSTS, '*') ) {
  				$wildcard_regex = array();
  				foreach ( $accessible_hosts as $host )
! 					$wildcard_regex[] = str_replace('\*', '[\w.]+?', preg_quote($host, '/'));
  				$wildcard_regex = '/^(' . implode('|', $wildcard_regex) . ')$/i';
  			}
  		}
--- 530,536 ----
  			if ( false !== strpos(WP_ACCESSIBLE_HOSTS, '*') ) {
  				$wildcard_regex = array();
  				foreach ( $accessible_hosts as $host )
! 					$wildcard_regex[] = str_replace( '\*', '.+', preg_quote( $host, '/' ) );
  				$wildcard_regex = '/^(' . implode('|', $wildcard_regex) . ')$/i';
  			}
  		}
***************
*** 593,622 ****
  
  		return $absolute_path . '/' . ltrim( $path, '/' );
  	}
  }
  
  /**
!  * HTTP request method uses fsockopen function to retrieve the url.
!  *
!  * This would be the preferred method, but the fsockopen implementation has the most overhead of all
!  * the HTTP transport implementations.
   *
   * @package WordPress
   * @subpackage HTTP
   * @since 2.7.0
   */
! class WP_Http_Fsockopen {
  	/**
! 	 * Send a HTTP request to a URI using fsockopen().
! 	 *
! 	 * Does not support non-blocking mode.
  	 *
  	 * @see WP_Http::request For default options descriptions.
  	 *
! 	 * @since 2.7
  	 * @access public
  	 * @param string $url URI resource.
! 	 * @param str|array $args Optional. Override the defaults.
  	 * @return array 'headers', 'body', 'response', 'cookies' and 'filename' keys.
  	 */
  	function request($url, $args = array()) {
--- 590,693 ----
  
  		return $absolute_path . '/' . ltrim( $path, '/' );
  	}
+ 
+ 	/**
+ 	 * Handles HTTP Redirects and follows them if appropriate.
+ 	 *
+ 	 * @since 3.7.0
+ 	 *
+ 	 * @param string $url The URL which was requested.
+ 	 * @param array $args The Arguements which were used to make the request.
+ 	 * @param array $response The Response of the HTTP request.
+ 	 * @return false|object False if no redirect is present, a WP_HTTP or WP_Error result otherwise.
+ 	 */
+ 	static function handle_redirects( $url, $args, $response ) {
+ 		// If no redirects are present, or, redirects were not requested, perform no action.
+ 		if ( ! isset( $response['headers']['location'] ) || 0 === $args['_redirection'] )
+ 			return false;
+ 
+ 		// Only perform redirections on redirection http codes
+ 		if ( $response['response']['code'] > 399 || $response['response']['code'] < 300 )
+ 			return false;
+ 
+ 		// Don't redirect if we've run out of redirects
+ 		if ( $args['redirection']-- <= 0 )
+ 			return new WP_Error( 'http_request_failed', __('Too many redirects.') );
+ 
+ 		$redirect_location = $response['headers']['location'];
+ 
+ 		// If there were multiple Location headers, use the last header specified
+ 		if ( is_array( $redirect_location ) )
+ 			$redirect_location = array_pop( $redirect_location );
+ 
+ 		$redirect_location = WP_HTTP::make_absolute_url( $redirect_location, $url );
+ 
+ 		// POST requests should not POST to a redirected location
+ 		if ( 'POST' == $args['method'] ) {
+ 			if ( in_array( $response['response']['code'], array( 302, 303 ) ) )
+ 				$args['method'] = 'GET';
+ 		}
+ 
+ 		// Include valid cookies in the redirect process
+ 		if ( ! empty( $response['cookies'] ) ) {
+ 			foreach ( $response['cookies'] as $cookie ) {
+ 				if ( $cookie->test( $redirect_location ) )
+ 					$args['cookies'][] = $cookie;
+ 			}
+ 		}
+ 
+ 		return wp_remote_request( $redirect_location, $args );
+ 	}
+ 
+ 	/**
+ 	 * Determines if a specified string represents an IP address or not.
+ 	 *
+ 	 * This function also detects the type of the IP address, returning either
+ 	 * '4' or '6' to represent a IPv4 and IPv6 address respectively.
+ 	 * This does not verify if the IP is a valid IP, only that it appears to be
+ 	 * an IP address.
+ 	 *
+ 	 * @see http://home.deds.nl/~aeron/regex/ for IPv6 regex
+ 	 *
+ 	 * @since 3.7.0
+ 	 * @static
+ 	 *
+ 	 * @param string $maybe_ip A suspected IP address
+ 	 * @return integer|bool Upon success, '4' or '6' to represent a IPv4 or IPv6 address, false upon failure
+ 	 */
+ 	static function is_ip_address( $maybe_ip ) {
+ 		if ( preg_match( '/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/', $maybe_ip ) )
+ 			return 4;
+ 
+ 		if ( false !== strpos( $maybe_ip, ':' ) && preg_match( '/^(((?=.*(::))(?!.*\3.+\3))\3?|([\dA-F]{1,4}(\3|:\b|$)|\2))(?4){5}((?4){2}|(((2[0-4]|1\d|[1-9])?\d|25[0-5])\.?\b){4})$/i', trim( $maybe_ip, ' []' ) ) )
+ 			return 6;
+ 
+ 		return false;
+ 	}
+ 
  }
  
  /**
!  * HTTP request method uses PHP Streams to retrieve the url.
   *
   * @package WordPress
   * @subpackage HTTP
+  *
   * @since 2.7.0
+  * @since 3.7.0 Combined with the fsockopen transport and switched to stream_socket_client().
   */
! class WP_Http_Streams {
  	/**
! 	 * Send a HTTP request to a URI using PHP Streams.
  	 *
  	 * @see WP_Http::request For default options descriptions.
  	 *
! 	 * @since 2.7.0
! 	 * @since 3.7.0 Combined with the fsockopen transport and switched to stream_socket_client().
! 	 *
  	 * @access public
  	 * @param string $url URI resource.
! 	 * @param string|array $args Optional. Override the defaults.
  	 * @return array 'headers', 'body', 'response', 'cookies' and 'filename' keys.
  	 */
  	function request($url, $args = array()) {
***************
*** 640,657 ****
  		// Construct Cookie: header if any cookies are set
  		WP_Http::buildCookieHeader( $r );
  
- 		$iError = null; // Store error number
- 		$strError = null; // Store error string
- 
  		$arrURL = parse_url($url);
  
! 		$fsockopen_host = $arrURL['host'];
! 
! 		$secure_transport = false;
  
  		if ( ! isset( $arrURL['port'] ) ) {
! 			if ( ( $arrURL['scheme'] == 'ssl' || $arrURL['scheme'] == 'https' ) && extension_loaded('openssl') ) {
! 				$fsockopen_host = "ssl://$fsockopen_host";
  				$arrURL['port'] = 443;
  				$secure_transport = true;
  			} else {
--- 711,723 ----
  		// Construct Cookie: header if any cookies are set
  		WP_Http::buildCookieHeader( $r );
  
  		$arrURL = parse_url($url);
  
! 		$connect_host = $arrURL['host'];
  
+ 		$secure_transport = ( $arrURL['scheme'] == 'ssl' || $arrURL['scheme'] == 'https' );
  		if ( ! isset( $arrURL['port'] ) ) {
! 			if ( $arrURL['scheme'] == 'ssl' || $arrURL['scheme'] == 'https' ) {
  				$arrURL['port'] = 443;
  				$secure_transport = true;
  			} else {
***************
*** 659,703 ****
  			}
  		}
  
! 		//fsockopen has issues with 'localhost' with IPv6 with certain versions of PHP, It attempts to connect to ::1,
  		// which fails when the server is not set up for it. For compatibility, always connect to the IPv4 address.
! 		if ( 'localhost' == strtolower($fsockopen_host) )
! 			$fsockopen_host = '127.0.0.1';
  
! 		// There are issues with the HTTPS and SSL protocols that cause errors that can be safely
! 		// ignored and should be ignored.
! 		if ( true === $secure_transport )
! 			$error_reporting = error_reporting(0);
  
! 		$startDelay = time();
  
  		$proxy = new WP_HTTP_Proxy();
  
  		if ( !WP_DEBUG ) {
  			if ( $proxy->is_enabled() && $proxy->send_through_proxy( $url ) )
! 				$handle = @fsockopen( $proxy->host(), $proxy->port(), $iError, $strError, $r['timeout'] );
  			else
! 				$handle = @fsockopen( $fsockopen_host, $arrURL['port'], $iError, $strError, $r['timeout'] );
  		} else {
  			if ( $proxy->is_enabled() && $proxy->send_through_proxy( $url ) )
! 				$handle = fsockopen( $proxy->host(), $proxy->port(), $iError, $strError, $r['timeout'] );
  			else
! 				$handle = fsockopen( $fsockopen_host, $arrURL['port'], $iError, $strError, $r['timeout'] );
  		}
  
! 		$endDelay = time();
  
! 		// If the delay is greater than the timeout then fsockopen shouldn't be used, because it will
! 		// cause a long delay.
! 		$elapseDelay = ($endDelay-$startDelay) > $r['timeout'];
! 		if ( true === $elapseDelay )
! 			add_option( 'disable_fsockopen', $endDelay, null, true );
  
! 		if ( false === $handle )
! 			return new WP_Error('http_request_failed', $iError . ': ' . $strError);
  
- 		$timeout = (int) floor( $r['timeout'] );
- 		$utimeout = $timeout == $r['timeout'] ? 0 : 1000000 * $r['timeout'] % 1000000;
  		stream_set_timeout( $handle, $timeout, $utimeout );
  
  		if ( $proxy->is_enabled() && $proxy->send_through_proxy( $url ) ) //Some proxies require full URL in this field.
--- 725,806 ----
  			}
  		}
  
! 		if ( isset( $r['headers']['Host'] ) || isset( $r['headers']['host'] ) ) {
! 			if ( isset( $r['headers']['Host'] ) )
! 				$arrURL['host'] = $r['headers']['Host'];
! 			else
! 				$arrURL['host'] = $r['headers']['host'];
! 			unset( $r['headers']['Host'], $r['headers']['host'] );
! 		}
! 
! 		// Certain versions of PHP have issues with 'localhost' and IPv6, It attempts to connect to ::1,
  		// which fails when the server is not set up for it. For compatibility, always connect to the IPv4 address.
! 		if ( 'localhost' == strtolower( $connect_host ) )
! 			$connect_host = '127.0.0.1';
  
! 		$connect_host = $secure_transport ? 'ssl://' . $connect_host : 'tcp://' . $connect_host;
  
! 		$is_local = isset( $r['local'] ) && $r['local'];
! 		$ssl_verify = isset( $r['sslverify'] ) && $r['sslverify'];
! 		if ( $is_local )
! 			$ssl_verify = apply_filters( 'https_local_ssl_verify', $ssl_verify );
! 		elseif ( ! $is_local )
! 			$ssl_verify = apply_filters( 'https_ssl_verify', $ssl_verify );
  
  		$proxy = new WP_HTTP_Proxy();
  
+ 		$context = stream_context_create( array(
+ 			'ssl' => array(
+ 				'verify_peer' => $ssl_verify,
+ 				//'CN_match' => $arrURL['host'], // This is handled by self::verify_ssl_certificate()
+ 				'capture_peer_cert' => $ssl_verify,
+ 				'SNI_enabled' => true,
+ 				'cafile' => $r['sslcertificates'],
+ 				'allow_self_signed' => ! $ssl_verify,
+ 			)
+ 		) );
+ 
+ 		$timeout = (int) floor( $r['timeout'] );
+ 		$utimeout = $timeout == $r['timeout'] ? 0 : 1000000 * $r['timeout'] % 1000000;
+ 		$connect_timeout = max( $timeout, 1 );
+ 
+ 		$connection_error = null; // Store error number
+ 		$connection_error_str = null; // Store error string
+ 
  		if ( !WP_DEBUG ) {
+ 			// In the event that the SSL connection fails, silence the many PHP Warnings
+ 			if ( $secure_transport )
+ 				$error_reporting = error_reporting(0);
+ 
  			if ( $proxy->is_enabled() && $proxy->send_through_proxy( $url ) )
! 				$handle = @stream_socket_client( 'tcp://' . $proxy->host() . ':' . $proxy->port(), $connection_error, $connection_error_str, $connect_timeout, STREAM_CLIENT_CONNECT, $context );
  			else
! 				$handle = @stream_socket_client( $connect_host . ':' . $arrURL['port'], $connection_error, $connection_error_str, $connect_timeout, STREAM_CLIENT_CONNECT, $context );
! 
! 			if ( $secure_transport )
! 				error_reporting( $error_reporting );
! 
  		} else {
  			if ( $proxy->is_enabled() && $proxy->send_through_proxy( $url ) )
! 				$handle = stream_socket_client( 'tcp://' . $proxy->host() . ':' . $proxy->port(), $connection_error, $connection_error_str, $connect_timeout, STREAM_CLIENT_CONNECT, $context );
  			else
! 				$handle = stream_socket_client( $connect_host . ':' . $arrURL['port'], $connection_error, $connection_error_str, $connect_timeout, STREAM_CLIENT_CONNECT, $context );
  		}
  
! 		if ( false === $handle ) {
! 			// SSL connection failed due to expired/invalid cert, or, OpenSSL configuration is broken
! 			if ( $secure_transport && 0 === $connection_error && '' === $connection_error_str )
! 				return new WP_Error( 'http_request_failed', __( 'The SSL certificate for the host could not be verified.' ) );
  
! 			return new WP_Error('http_request_failed', $connection_error . ': ' . $connection_error_str );
! 		}
  
! 		// Verify that the SSL certificate is valid for this request
! 		if ( $secure_transport && $ssl_verify && ! $proxy->is_enabled() ) {
! 			if ( ! self::verify_ssl_certificate( $handle, $arrURL['host'] ) )
! 				return new WP_Error( 'http_request_failed', __( 'The SSL certificate for the host could not be verified.' ) );
! 		}
  
  		stream_set_timeout( $handle, $timeout, $utimeout );
  
  		if ( $proxy->is_enabled() && $proxy->send_through_proxy( $url ) ) //Some proxies require full URL in this field.
***************
*** 736,742 ****
  		fwrite($handle, $strHeaders);
  
  		if ( ! $r['blocking'] ) {
! 			fclose($handle);
  			return array( 'headers' => array(), 'body' => '', 'response' => array('code' => false, 'message' => false), 'cookies' => array() );
  		}
  
--- 839,846 ----
  		fwrite($handle, $strHeaders);
  
  		if ( ! $r['blocking'] ) {
! 			stream_set_blocking( $handle, 0 );
! 			fclose( $handle );
  			return array( 'headers' => array(), 'body' => '', 'response' => array('code' => false, 'message' => false), 'cookies' => array() );
  		}
  
***************
*** 770,779 ****
  					}
  				}
  
! 				if ( isset( $r['limit_response_size'] ) && ( $bytes_written + strlen( $block ) ) > $r['limit_response_size'] )
  					$block = substr( $block, 0, ( $r['limit_response_size'] - $bytes_written ) );
  
! 				$bytes_written += fwrite( $stream_handle, $block );
  
  				$keep_reading = !isset( $r['limit_response_size'] ) || $bytes_written < $r['limit_response_size'];
  			}
--- 874,893 ----
  					}
  				}
  
! 				$this_block_size = strlen( $block );
! 
! 				if ( isset( $r['limit_response_size'] ) && ( $bytes_written + $this_block_size ) > $r['limit_response_size'] )
  					$block = substr( $block, 0, ( $r['limit_response_size'] - $bytes_written ) );
  
! 				$bytes_written_to_file = fwrite( $stream_handle, $block );
! 
! 				if ( $bytes_written_to_file != $this_block_size ) {
! 					fclose( $handle );
! 					fclose( $stream_handle );
! 					return new WP_Error( 'http_request_failed', __( 'Failed to write request to temporary file.' ) );
! 				}
! 
! 				$bytes_written += $bytes_written_to_file;
  
  				$keep_reading = !isset( $r['limit_response_size'] ) || $bytes_written < $r['limit_response_size'];
  			}
***************
*** 799,817 ****
  
  		fclose( $handle );
  
! 		if ( true === $secure_transport )
! 			error_reporting($error_reporting);
  
! 		$arrHeaders = WP_Http::processHeaders( $process['headers'] );
  
! 		// If location is found, then assume redirect and redirect to location.
! 		if ( isset($arrHeaders['headers']['location']) && 0 !== $r['_redirection'] ) {
! 			if ( $r['redirection']-- > 0 ) {
! 				return wp_remote_request( WP_HTTP::make_absolute_url( $arrHeaders['headers']['location'], $url ), $r);
! 			} else {
! 				return new WP_Error('http_request_failed', __('Too many redirects.'));
! 			}
! 		}
  
  		// If the body was chunk encoded, then decode it.
  		if ( ! empty( $process['body'] ) && isset( $arrHeaders['headers']['transfer-encoding'] ) && 'chunked' == $arrHeaders['headers']['transfer-encoding'] )
--- 913,931 ----
  
  		fclose( $handle );
  
! 		$arrHeaders = WP_Http::processHeaders( $process['headers'], $url );
  
! 		$response = array(
! 			'headers' => $arrHeaders['headers'],
! 			'body' => null, // Not yet processed
! 			'response' => $arrHeaders['response'],
! 			'cookies' => $arrHeaders['cookies'],
! 			'filename' => $r['filename']
! 		);
  
! 		// Handle redirects
! 		if ( false !== ( $redirect_response = WP_HTTP::handle_redirects( $url, $r, $response ) ) )
! 			return $redirect_response;
  
  		// If the body was chunk encoded, then decode it.
  		if ( ! empty( $process['body'] ) && isset( $arrHeaders['headers']['transfer-encoding'] ) && 'chunked' == $arrHeaders['headers']['transfer-encoding'] )
